// geometry.h
// DEFINOVANIE ZAKLADNYCH GEOMETRICKYCH OBJEKTOV

// GLEW kniznica. pre spravu novsich rozsireni
#include "glew.h"
#include "meshes.h"

// vytvorenie modelu jednotkovej kocky bez materialu
Model* CreateCubeModel();

// vytvorenie modelu pre renderovanie sfery bez material
Model* CreateSphereModel(int xSlices, int ySlices);

// vytvorenie modelu pre renderovanie torusu bez materialu
Model* CreateTorusModel(float innerRadius, float outerRadius, int xSlices, int ySlices);

// funkcia na vypocet tangent pre kazy vrchol na zaklade pozicii a texturnych koordinat vrcholov
// vo vysledku su tangenty znormalizovane, kolme na normalu, so stvrtou suradnicou obsahujucou informaciu od orientacii tangencialneho priestoru
void CalculateTangentArray(GLuint num_vertices, float* vertices_3D, float* normals_3D,
        float* texcoords_2D, GLenum polygon_mode, int num_indices, GLuint* indices, float* final_tangents_4D);

// vypocitaj polygony ktore predtsavuju prieniky rovin kolmych na pohlad z kamery s normalizovanou kockou <-1,1>x<-1,1>x<-1,1> v svetovych suradniciach
// zadana je poza kamery v svetovych suradniciach a vzdialenost dvoch susednych rovin
std::vector< std::vector<aiVector3D> >GetCubeSlices(ObjectPose camera_pose, float dist_delta);