
varying vec4 R_world;
varying vec4 V_world;
varying vec4 N_world;
varying vec4 L_world;

uniform mat4 camera_view_matrix;
uniform vec4 camera_world_pos;
uniform vec4 light_world_pos;

void main(void)
{
   V_world = normalize(camera_world_pos - gl_ModelViewMatrix * gl_Vertex);
   N_world = vec4(normalize(gl_NormalMatrix * gl_Normal), 0.0);
   L_world = light_world_pos - gl_ModelViewMatrix * gl_Vertex;
   R_world = reflect(-V_world, N_world);
   
   gl_TexCoord[0] = gl_MultiTexCoord0;
   gl_Position = gl_ProjectionMatrix * camera_view_matrix * gl_ModelViewMatrix * gl_Vertex;
}

