varying vec4 V_eye;
varying vec4 L_eye;
varying vec4 N_eye;

uniform int lighting_enabled;

void main(void)
{
   vec4 color = gl_FrontMaterial.diffuse;
   if (lighting_enabled > 0)
   {
	   vec4 V = normalize(V_eye);
   	   vec4 L = normalize(L_eye);
   	   vec4 N = normalize(N_eye); 

	   float diffuse = clamp(dot(L, N), 0.0, 1.0);
   	   vec4 R = reflect(-L, N);
   	   float specular = pow(clamp(dot(R, V), 0.0, 1.0), gl_FrontMaterial.shininess);

	   color = 0.2 * (vec4(0.2, 0.2, 0.2, 1.0) + gl_LightSource[0].ambient) * (gl_FrontMaterial.ambient + gl_FrontMaterial.diffuse);
	   color += diffuse * gl_LightSource[0].diffuse * gl_FrontMaterial.diffuse;
	   color += specular * gl_LightSource[0].specular * gl_FrontMaterial.specular;
   }

   gl_FragColor = color;
}
