#version 120
#extension GL_ARB_geometry_shader4 : enable

varying vec4 V_eye;
varying vec4 L_eye;
varying vec4 N_eye;
varying vec3 barycentric_coords;
uniform float size;

void EmitByDisplacement(vec4 displacement, vec3 bary)
{
   V_eye = gl_ModelViewMatrix * (gl_PositionIn[0] + displacement);
   N_eye = vec4(gl_NormalMatrix * normalize(displacement.xyz), 0.0);
   L_eye = gl_LightSource[0].position - V_eye;
   barycentric_coords = bary;
   gl_Position = gl_ProjectionMatrix * V_eye;
   V_eye = -V_eye;
   EmitVertex();
}

void main(void)
{
   EmitByDisplacement(vec4(size, 0.0, 0.0, 0.0), vec3(1.0, 0.0, 0.0));
   EmitByDisplacement(vec4(-size, 0.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0));
   EmitByDisplacement(vec4(0.0, size, 0.0, 0.0), vec3(0.0, 0.0, 1.0));
   EndPrimitive();
   
   EmitByDisplacement(vec4(size, 0.0, 0.0, 0.0), vec3(1.0, 0.0, 0.0));
   EmitByDisplacement(vec4(0.0, -size, 0.0, 0.0), vec3(0.0, 1.0, 0.0));
   EmitByDisplacement(vec4(-size, 0.0, 0.0, 0.0), vec3(0.0, 0.0, 1.0));
   EndPrimitive();
   
   EmitByDisplacement(vec4(size, 0.0, 0.0, 0.0), vec3(1.0, 0.0, 0.0));
   EmitByDisplacement(vec4(0.0, size, 0.0, 0.0), vec3(0.0, 1.0, 0.0));
   EmitByDisplacement(vec4(0.0, 0.0, size, 0.0), vec3(0.0, 0.0, 1.0));
   EndPrimitive();
   
   EmitByDisplacement(vec4(0.0, size, 0.0, 0.0), vec3(1.0, 0.0, 0.0));
   EmitByDisplacement(vec4(-size, 0.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0));
   EmitByDisplacement(vec4(0.0, 0.0, size, 0.0), vec3(0.0, 0.0, 1.0));
   EndPrimitive();
   
   EmitByDisplacement(vec4(-size, 0.0, 0.0, 0.0), vec3(1.0, 0.0, 0.0));
   EmitByDisplacement(vec4(0.0, -size, 0.0, 0.0), vec3(0.0, 1.0, 0.0));
   EmitByDisplacement(vec4(0.0, 0.0, size, 0.0), vec3(0.0, 0.0, 1.0));
   EndPrimitive();
   
   EmitByDisplacement(vec4(0.0, -size, 0.0, 0.0), vec3(1.0, 0.0, 0.0));
   EmitByDisplacement(vec4(size, 0.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0));
   EmitByDisplacement(vec4(0.0, 0.0, size, 0.0), vec3(0.0, 0.0, 1.0));
   EndPrimitive();
}

