varying vec2 vTexCoord;

uniform sampler2D map;
uniform float min_luminance;

void main() 
{
    vec4 color = texture2D(map, vTexCoord);
    float luminance = 0.3 * color.r + 0.59 * color.g + 0.11 * color.b;
    if (luminance < min_luminance)
        color = vec4(0.0, 0.0, 0.0, 1.0);
    gl_FragColor = color;
}

