
uniform vec4 zoom_rectangle;
uniform vec3 julia_param;
uniform vec4 base_color;
uniform int iterations;

void main(void)
{
   float cx = zoom_rectangle.x + gl_TexCoord[0].s * zoom_rectangle.z;
   float cy = zoom_rectangle.y + gl_TexCoord[0].t * zoom_rectangle.w;
   float orbit_x = cx;
   float orbit_y = cy;
   int i = 0;
   for (i = 0; i < iterations; i++)
   {
      if ( orbit_x * orbit_x + orbit_y * orbit_y > 4)
         break;
      float temp_x = orbit_x * orbit_x - orbit_y * orbit_y;
      float temp_y = 2 * orbit_x * orbit_y;
      if (julia_param.z > 0)
      {
          orbit_x = temp_x + julia_param.x;
          orbit_y = temp_y + julia_param.y;
      }
      else
      {
          orbit_x = temp_x + cx;
          orbit_y = temp_y + cy;
      }
   }

   gl_FragColor = base_color * vec4(i / float(iterations), i / float(iterations), 0.3, 1.0);
}
