varying vec4 V_eye;
varying vec4 L_eye;
varying vec4 N_eye;
uniform int grid_size;
uniform vec2 scale;

void main(void)
{
   int x_index = gl_InstanceID / grid_size;
   int y_index = gl_InstanceID - grid_size * x_index;
   
   mat4 trans;
   trans[0] = vec4(1.0, 0.0, 0.0, 0.0);
   trans[1] = vec4(0.0, 1.0, 0.0, 0.0);
   trans[2] = vec4(0.0, 0.0, 1.0, 0.0);
   trans[3] = vec4(scale.x * (x_index - 0.5 * grid_size), scale.y * (y_index - 0.5 * grid_size), 0.0, 1.0);
   V_eye = gl_ModelViewMatrix * trans * gl_Vertex;
   L_eye = gl_LightSource[0].position - V_eye;
   N_eye = vec4(gl_NormalMatrix * gl_Normal, 0.0);
   
   gl_TexCoord[0] = gl_MultiTexCoord0;
   gl_Position = gl_ProjectionMatrix * V_eye;
   V_eye = -V_eye;
}

