varying vec2 vTexCoord;

uniform sampler2D map, bloom_map;
uniform float exposure;
uniform float bloom_factor;
uniform float max_bright;

void main() 
{
    vec4 color = texture2D(map, vTexCoord);
    vec4 bloom_color = texture2D(bloom_map, vTexCoord);
    color += bloom_color * bloom_factor;

    float tone_coeff = exposure * (exposure / max_bright + 1.0) / (exposure + 1.0);

    gl_FragColor = tone_coeff * color;
}

